package com.eactive.eai.batch.job.jobItem.school;

import java.lang.String;
import java.io.ByteArrayOutputStream;
import java.io.File;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

public class SEND_SCBANK_130 extends DefaultTelegram implements TelegramService
{

	private int     SEND_LENGTH;
    private int     REAL_SEND_LENGTH;

    /**
     * 생성자
     */
    public SEND_SCBANK_130() {
        //수신확인
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            if ( !calculateSendLength() ) return false;

            //길이 필드 + TR CODE 향후 TCP/IP로 전환 될 것을 대비 하여 길이와 TR CODE를 하나의 필드로 간주 하여 처리 한다.
            compileField(0, makeZero(""+SEND_LENGTH, 4), this.al_FieldProps[0]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(1, this.getFldTelegramType().substring(0,3), this.al_FieldProps[1]);

            //응답코드
            compileField(2, this.getResolveResponseCode(), this.al_FieldProps[2]);

            //업무필드
            compileField(3, "", this.al_FieldProps[3]);
            
            //예비
            compileField(4, "", this.al_FieldProps[4]);
            
            //FILE NAME
            compileField(5, batchDoc.getBatchMsg().getHeader().getFileName(), this.al_FieldProps[5]);

            //FILE SIZE
            compileField(6, ""+batchDoc.getBatchMsg().getHeader().getFileSize(), this.al_FieldProps[6]);
            
            //처리여부
            if ( this.getResolveResponseCode().equals(TelegramKeys.MAGIC_RES_CODE_SUCESS)) {
                compileField(7, "Y", this.al_FieldProps[7]);
            } else {
                compileField(7, "N", this.al_FieldProps[7]);
            }

            //FILLER
            compileField(8, "", this.al_FieldProps[8]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
    	return REAL_SEND_LENGTH;
    }

    private boolean calculateSendLength () {
        try {
            for (int i=0; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH;
            SEND_LENGTH -= 4;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            long fileSize  = batchDoc.getBatchMsg().getHeader().getFileSize();
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize();
            if ( fileSize != lnCurSize ){
            	this.setResolveResponseCode( TelegramKeys.MAGIC_RES_CODE_ETC_ERROR );
            }
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<5; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=5; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
            //수신 파일 관련 처리
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getFileName();
            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }
            String fileName = fileDir + fileNm;

			File rcvRealFile = new File( fileName );
			File rcvArchFile = new File( StringUtil.realToArchDir(fileName) );
			File rcvRootFile = new File( StringUtil.realToRootDir(fileName) );

            if ((fileNm != null) && (!fileNm.trim().equals(""))&& (rcvRealFile.exists())) {

				//DB로그에 남길 파일 헤더,트레일러 내용 설정
				super.setFileHeaderAndTrailer(rcvRealFile);

				//수신 Real 디렉토리 -> Arch 디렉토리로 파일 이동 (파일명 변경 안한고 동일 파일명 존재시 Overwrite)
				logger.info("{} >>>>> 수신 파일을 수신 Real 디렉토리 -> 수신 Arch 디렉토리로 이동.....", logHeader);
				boolean isSuccessMoveFile = rcvRealFile.renameTo(rcvArchFile);
				if (!isSuccessMoveFile) {
					String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI030", new String[] {rcvRealFile.getAbsolutePath(), rcvArchFile.getAbsolutePath()});
					batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);	//수신 파일을 수신 Real 디렉토리에서 수신 Arch 디렉로 이동시 오류가 발생하였습니다. [Real Path: {1}] [Arch Path: {2}]
					super.setResolveResponseCode(TelegramKeys.RPS_HDB_RET_CODE_OTHER_ERROR);
					return true;  //다음단계 수행시 응답코드를 기준으로 에러전문을 송신하기위해 true 설정함
				}
				//DB로그에 남길 변경 파일명 설정 (파일명 변경 안함)
				batchDoc.getBatchMsg().getHeader().setRenamedFileName(fileName);
				
				logger.info("{} >>>>> 수신 파일과 동일 파일명의 0 Byte 파일을 Root 디렉토리에 생성......(HOST에 자동 송신하도록 수신 File Event 발생)", logHeader);	
    			try {
    				isSuccessMoveFile = rcvRootFile.createNewFile();
				} catch (Exception e) { } // 실패인 경우 무시하고 로깅만 하도록....
    			
    			if (!isSuccessMoveFile) {
    				String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI031", new String[] {rcvRootFile.getAbsolutePath()});
    				batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);	//수신 Root 디렉토리에 0 Byte 파일을 생성할 수 없습니다. [Path: {1}]
    			}
            }
				//수신 파일 End DB로그
				LogUtil.setLogFileEnd(batchDoc);
	            String isNofile = batchDoc.getBatchMsg().getBody().getSendSummary();
	            if ( isNofile.equals(TelegramKeys.MAGICLINK_END)){
	            	setConditionTxt(TelegramKeys.NOFILE);
	            }

				return true;
            
        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }


    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(1);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(2);
    }
}

